package com.pj.tb_goods_type;

import java.util.List;
import com.pj.utils.so.SoMap;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import com.pj.utils.sg.*;
import com.pj.project4sp.SP;

import cn.dev33.satoken.annotation.SaCheckPermission;


/**
 * Controller: tb_goods_type -- 商品分类
 * @author qzy 
 */
@RestController
@RequestMapping("/TbGoodsType/")
public class TbGoodsTypeController {

	/** 底层 Service 对象 */
	@Autowired
	TbGoodsTypeService tbGoodsTypeService;

	/** 增 */  
	@RequestMapping("add")
//	@SaCheckPermission(TbGoodsType.PERMISSION_CODE_ADD)
	public AjaxJson add(TbGoodsType t){
		tbGoodsTypeService.add(t);
		t = tbGoodsTypeService.getById(SP.publicMapper.getPrimarykey());
		return AjaxJson.getSuccessData(t);
	}

	/** 删 */  
	@RequestMapping("delete")
//	@SaCheckPermission(TbGoodsType.PERMISSION_CODE_DEL)
	public AjaxJson delete(String id){
		 tbGoodsTypeService.delete(Long.valueOf(id));
		return AjaxJson.getSuccess();
	}
	
	/** 删 - 根据id列表 */  
	@RequestMapping("deleteByIds")
//	@SaCheckPermission(TbGoodsType.PERMISSION_CODE_DEL)
	public AjaxJson deleteByIds(){
		List<Long> ids = SoMap.getRequestSoMap().getListByComma("ids", long.class); 
		int line = SP.publicMapper.deleteByIds(TbGoodsType.TABLE_NAME, ids);
		return AjaxJson.getByLine(line);
	}
	
	/** 改 */  
	@RequestMapping("update")
//	@SaCheckPermission(TbGoodsType.PERMISSION_CODE_EDIT)
	public AjaxJson update(TbGoodsType t){
		tbGoodsTypeService.update(t);
		return AjaxJson.getSuccess();
	}

	/** 查 - 根据id */  
	@RequestMapping("getById")
//		@SaCheckPermission(TbGoodsType.PERMISSION_CODE)
	public AjaxJson getById(String id){
		TbGoodsType t = tbGoodsTypeService.getById(id);
		return AjaxJson.getSuccessData(t);
	}

	/** 查集合 - 根据条件（参数为空时代表忽略指定条件） */  
	@RequestMapping("getList")
//		@SaCheckPermission(TbGoodsType.PERMISSION_CODE)
	public AjaxJson getList() { 
		SoMap so = SoMap.getRequestSoMap();
		List<TbGoodsType> list = tbGoodsTypeService.getList(so.startPage());
		return AjaxJson.getPageData(so.getDataCount(), list);
	}
	
	/** 查集合 (整个表数据转化为tree结构返回) */  
	@RequestMapping("getTree")
	public AjaxJson getTree() { 
		// 获取记录 
		SoMap so = SoMap.getRequestSoMap();
		List<TbGoodsType> list = tbGoodsTypeService.getList(so);
		// 转为tree结构，并返回 
		List<SoMap> listMap = SoMap.getSoMapByList(list);
		List<SoMap> listTree = SoMap.listToTree(listMap, "id", "parentId", "children");
		return AjaxJson.getPageData(Long.valueOf(listMap.size()), listTree);
	}
	
	
	/** 改 - 删除状态(0=禁用,1=启用) */  
	@RequestMapping("updateDeleteStatus")
	@SaCheckPermission(TbGoodsType.PERMISSION_CODE_EDIT)
	public AjaxJson updateDeleteStatus(String id, Integer value){
		int line = SP.publicMapper.updateColumnById(TbGoodsType.TABLE_NAME, "delete_status", value, id);
		return AjaxJson.getByLine(line);
	}

	/**
	 *
	 *给商品类型添加商品
	 * @author loovi
	 * @date
	 */
	@RequestMapping("addGoodsToGoodsType")
	@SaCheckPermission(TbGoodsType.PERMISSION_CODE_EDIT)
	public AjaxJson addGoodsToGoodsType(@RequestParam("goodsTypeId") Long goodsTypeId,@RequestParam("goodsIds") Long [] goodsIds){
		int  line = tbGoodsTypeService.addGoodsToGoodsType(goodsTypeId,goodsIds);
		return AjaxJson.getByLine(line);
	}

	/**
	 *
	 *删除商品类型中的商品
	 * @author loovi
	 * @date
	 */
	@RequestMapping("delGoodsFromGoodsType")
	@SaCheckPermission(TbGoodsType.PERMISSION_CODE_EDIT)
	public AjaxJson delGoodsFromGoodsType(@RequestParam("goodsTypeId") Long goodsTypeId,@RequestParam("goodsIds") Long [] goodsIds){
		int  line = tbGoodsTypeService.delGoodsFromGoodsType(goodsTypeId,goodsIds);
		return AjaxJson.getByLine(line);
	}

	
	
	

}
